Index: tmp/org.txm.tigersearch.rcp/src/org/txm/function/tigersearch/TSIndex.java
===================================================================
--- tmp/org.txm.tigersearch.rcp/src/org/txm/function/tigersearch/TSIndex.java	(revision 722)
+++ tmp/org.txm.tigersearch.rcp/src/org/txm/function/tigersearch/TSIndex.java	(revision 723)
@@ -4,7 +4,6 @@
 import ims.tiger.corpus.Node;
 import ims.tiger.corpus.Sentence;
 import ims.tiger.corpus.T_Node;
-import ims.tiger.gui.tigergraphviewer.draw.Display_Sentence;
 import ims.tiger.gui.tigergraphviewer.forest.ResultForest;
 import ims.tiger.query.api.MatchResult;
 import ims.tiger.query.internalapi.InternalCorpusQueryManager;
@@ -18,27 +17,21 @@
 import java.util.List;
 import java.util.regex.Pattern;
 
-import org.txm.Toolbox;
 import org.txm.index.core.functions.Index;
 import org.txm.index.core.functions.Line;
 import org.txm.searchengine.cqp.AbstractCqiClient;
 import org.txm.searchengine.cqp.CQPEngine;
-import org.txm.searchengine.cqp.ICqiClient;
 import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
-import org.txm.searchengine.cqp.clientExceptions.UnexpectedAnswerException;
 import org.txm.searchengine.cqp.corpus.Corpus;
 import org.txm.searchengine.cqp.corpus.CorpusManager;
 import org.txm.searchengine.cqp.corpus.Partition;
 import org.txm.searchengine.cqp.corpus.Property;
-import org.txm.searchengine.cqp.corpus.QueryResult;
 import org.txm.searchengine.cqp.corpus.StructuralUnitProperty;
 import org.txm.searchengine.cqp.corpus.query.Match;
-import org.txm.searchengine.cqp.corpus.query.MatchUtils;
 import org.txm.searchengine.cqp.corpus.query.Query;
 import org.txm.searchengine.cqp.serverException.CqiServerError;
 import org.txm.searchengine.ts.TSCorpus;
 import org.txm.searchengine.ts.TSCorpusManager;
-import org.txm.searchengine.ts.TSMatch;
 import org.txm.searchengine.ts.TSResult;
 import org.txm.utils.logger.Log;
 
Index: tmp/org.txm.index.rcp/src/org/txm/index/rcp/editors/IndexEditor.java
===================================================================
--- tmp/org.txm.index.rcp/src/org/txm/index/rcp/editors/IndexEditor.java	(revision 722)
+++ tmp/org.txm.index.rcp/src/org/txm/index/rcp/editors/IndexEditor.java	(revision 723)
@@ -30,20 +30,12 @@
 import java.util.ArrayList;
 import java.util.List;
 
-import org.eclipse.core.runtime.IProgressMonitor;
-import org.eclipse.core.runtime.IStatus;
-import org.eclipse.core.runtime.Status;
-import org.eclipse.jface.action.MenuManager;
 import org.eclipse.jface.viewers.TableViewer;
-import org.eclipse.osgi.util.NLS;
 import org.eclipse.swt.SWT;
-import org.eclipse.swt.events.KeyEvent;
-import org.eclipse.swt.events.KeyListener;
 import org.eclipse.swt.events.SelectionEvent;
 import org.eclipse.swt.events.SelectionListener;
 import org.eclipse.swt.graphics.Font;
 import org.eclipse.swt.graphics.FontData;
-import org.eclipse.swt.graphics.Point;
 import org.eclipse.swt.layout.FormAttachment;
 import org.eclipse.swt.layout.FormData;
 import org.eclipse.swt.layout.FormLayout;
@@ -52,40 +44,29 @@
 import org.eclipse.swt.widgets.Button;
 import org.eclipse.swt.widgets.Composite;
 import org.eclipse.swt.widgets.Display;
-import org.eclipse.swt.widgets.Event;
 import org.eclipse.swt.widgets.Label;
-import org.eclipse.swt.widgets.Listener;
-import org.eclipse.swt.widgets.Menu;
 import org.eclipse.swt.widgets.Spinner;
 import org.eclipse.swt.widgets.TableColumn;
-import org.eclipse.ui.IEditorInput;
-import org.eclipse.ui.IEditorSite;
-import org.eclipse.ui.PartInitException;
 import org.txm.core.messages.TXMCoreMessages;
-import org.txm.core.preferences.TXMPreferences;
-import org.txm.core.results.TXMResult;
+import org.txm.core.results.Parameter;
 import org.txm.index.core.functions.Index;
 import org.txm.index.core.functions.Line;
 import org.txm.index.core.functions.LineComparator.SortMode;
 import org.txm.index.core.preferences.IndexPreferences;
 import org.txm.index.rcp.messages.IndexUIMessages;
-import org.txm.rcp.JobsTimer;
 import org.txm.rcp.StatusLine;
 import org.txm.rcp.editors.TXMEditor;
-import org.txm.rcp.editors.TXMResultEditorInput;
 import org.txm.rcp.editors.TableKeyListener;
+import org.txm.rcp.editors.listeners.ComputeKeyListener;
+import org.txm.rcp.editors.listeners.ComputeSelectionListener;
 import org.txm.rcp.messages.TXMUIMessages;
-import org.txm.rcp.preferences.RCPPreferences;
 import org.txm.rcp.swt.widget.AssistedQueryWidget;
 import org.txm.rcp.swt.widget.NavigationWidget;
 import org.txm.rcp.swt.widget.PropertiesSelector;
-import org.txm.rcp.utils.JobHandler;
 import org.txm.rcp.views.QueriesView;
-import org.txm.searchengine.cqp.CQPEngine;
 import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
 import org.txm.searchengine.cqp.corpus.Corpus;
 import org.txm.searchengine.cqp.corpus.Property;
-import org.txm.searchengine.cqp.corpus.StructuralUnitProperty;
 import org.txm.searchengine.cqp.corpus.WordProperty;
 import org.txm.searchengine.cqp.corpus.query.Query;
 import org.txm.statsengine.r.rcp.views.RVariablesView;
@@ -105,26 +86,10 @@
 	/** The query label. */
 	protected Label queryLabel;
 
-	/** The query widget. */
-	protected AssistedQueryWidget queryWidget;
-
 	/** The go. */
-	protected Button go;
+	protected Button searchButton;
 
-	/** The props area. */
-	protected PropertiesSelector<Property> propsArea;
-	// seuils
-	/** The Fmin spinner. */
-	protected Spinner fMinSpinner;
 
-	/** The Fmax spinner. */
-	protected Spinner fMaxSpinner;
-
-	/** The Tmax spinner. */
-	protected Spinner vMaxSpinner;
-
-	/** The N ligne p page spinner. */
-	protected Spinner nLinesPerPageSpinner;
 	// infos
 	/** The navigation area. */
 	protected NavigationWidget navigationArea;
@@ -160,112 +125,35 @@
 	/** The title. */
 	String title;
 
+	
+	
+	/** The query widget. */
+	@Parameter(key=IndexPreferences.QUERY)
+	protected AssistedQueryWidget queryWidget;
 
-	/**
-	 * Inits the editor result.
-	 *
-	 * @param site the site
-	 * @param input the input
-	 * @throws PartInitException the part init exception
-	 * @see org.eclipse.ui.part.EditorPart#init(org.eclipse.ui.IEditorSite,
-	 * org.eclipse.ui.IEditorInput)
-	 */
-	@Override
-	public void init(IEditorSite site, IEditorInput input) throws PartInitException {
-		super.init(site, input);
+	/** The Fmin spinner. */
+	@Parameter(key=IndexPreferences.F_MIN)
+	protected Spinner fMinSpinner;
 
-		TXMResult result = ((TXMResultEditorInput) input).getResult();
-		if (result != null && result instanceof Index) {
-			this.index = (Index) result;
-		}
-		else { 
-			throw new PartInitException("TXMResult input is not an Index: " + result);
-		}
-	}
+	/** The Fmax spinner. */
+	@Parameter(key=IndexPreferences.F_MAX)
+	protected Spinner fMaxSpinner;
 
+	/** The Tmax spinner. */
+	@Parameter(key=IndexPreferences.V_MAX)
+	protected Spinner vMaxSpinner;
 
-	@Override
-	public void updateResultFromEditor() {
-		final Query query = new Query("");
-		if (!queryWidget.isDisposed() && !queryWidget.getQueryString().equals("\"\"")) { //$NON-NLS-1$
-			query.setQueryString(queryWidget.getQueryString());
-		}
-
-		final Integer fMin = Integer.parseInt(fMinSpinner.getText());
-		final Integer fMax = Integer.parseInt(fMaxSpinner.getText());
-		final Integer tMax = Integer.parseInt(this.vMaxSpinner.getText());
-		final Integer nLines = Integer.parseInt(this.nLinesPerPageSpinner.getText());
-		final List<Property> properties = propsArea.getSelectedProperties();
-		
-		index.setNLinesPerPage(nLinesPerPageSpinner.getSelection());
-		index.setVMax(vMaxSpinner.getSelection());
-		
-		index.setParameters(query, properties, fMin, fMax, tMax, nLines);
-		index.setDirty();
-	}
-
+	/** The N ligne p page spinner. */
+	@Parameter(key=IndexPreferences.N_LINES_PER_PAGE)
+	protected Spinner nLinesPerPageSpinner;
 	
 	/**
-	 * Computes index.
+	 * Word properties selector.
 	 */
-	@Override
-	public void updateEditorFromResult(final boolean update) {
-		
-		//System.out.println("PROPERTIES: "+properties);
-//		title = "Index...";
-//		try {
-//			JobHandler jobhandler = new JobHandler(title) {
-//				@Override
-//				protected IStatus run(IProgressMonitor monitor) {
-//					this.runInit(monitor);
-//					try {
-//						JobsTimer.start();
-//
-//						monitor.worked(95);
-//						// refresh ui
-//						syncExec(new Runnable() {
-//							@Override
-//							public void run() {
+	@Parameter(key=IndexPreferences.PROPERTIES)
+	protected PropertiesSelector<WordProperty> propertiesSelector;
+	
 
-								QueriesView.refresh();
-								RVariablesView.refresh();
-
-								if (!queryWidget.isDisposed()) {
-									queryWidget.memorize();
-								}
-								
-								fillDisplayArea();
-
-								viewer.getTable().setFocus();
-//							}
-//						});
-//
-//					} catch (ThreadDeath td) {
-//						return Status.CANCEL_STATUS;
-//					} catch (Exception e) {
-//						e.printStackTrace();
-//						System.out.println(e.getLocalizedMessage());
-//						try {
-//							System.out.println(RCPMessages.LastCQPError+CQPEngine.getCqiClient().getLastCQPError());
-//						} catch (Exception e1) {
-//							System.out.println(IndexUIMessages.IndexEditor_10+e1);
-//							org.txm.rcp.utils.Logger.printStackTrace(e1);
-//						}
-//						Log.severe("Error while computing Index: "+e.getLocalizedMessage());
-//					} finally {
-//						monitor.done();
-//						JobsTimer.stopAndPrint();
-//					}
-//					return Status.OK_STATUS;
-//				}
-//			};
-//			jobhandler.startJob();
-//
-//		} catch (Exception e1) {
-//			org.txm.rcp.utils.Logger.printStackTrace(e1);
-//		}
-	}
-
 	/**
 	 * Creates the part control.
 	 *
@@ -274,8 +162,15 @@
 	 */
 	@Override
 	public void _createPartControl(Composite parent) {
-//		super.createPartControl(parent);
 
+		
+		this.index = (Index) this.getResult();
+
+		
+		// Computing listener
+		ComputeSelectionListener computeSelectionListener = new ComputeSelectionListener(this);
+		ComputeKeyListener computeKeyListener = new ComputeKeyListener(this);
+		
 		Composite paramArea = this.getCommandParametersGroup();
 		paramArea.setLayout(new FormLayout());
 
@@ -300,9 +195,8 @@
 		// | Query: [ (v)] [Search] |
 		// Query:
 		queryLabel = new Label(queryArea, SWT.NONE);
-		queryLabel.setText(TXMCoreMessages.QUERY_1);
-		queryLabel.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false,
-				true));
+		queryLabel.setText(TXMCoreMessages.common_query);
+		queryLabel.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, true));
 
 		// [ (v)]
 		queryWidget = new AssistedQueryWidget(queryArea, SWT.DROP_DOWN,	index.getCorpus());
@@ -310,61 +204,38 @@
 		layoutData.horizontalAlignment = GridData.FILL;
 		layoutData.grabExcessHorizontalSpace = true;
 		queryWidget.setLayoutData(layoutData);
+		queryWidget.addKeyListener(computeKeyListener);
 
-		KeyListener listener = new KeyListener() {
-			@Override
-			public void keyPressed(KeyEvent e) {
-				if (e.keyCode == SWT.CR || e.keyCode == SWT.KEYPAD_CR) {
-					updateResultFromEditor();
-					compute(true);
-				}
-			}
-			@Override
-			public void keyReleased(KeyEvent e) {
-			}
-		};
-		queryWidget.addKeyListener(listener);
+		
+		// Word properties selector
+		propertiesSelector = new PropertiesSelector<WordProperty>(queryArea, SWT.NONE);
+		propertiesSelector.setLayoutData(new GridData(GridData.FILL, GridData.FILL, false, false));
+		propertiesSelector.setLayout(new GridLayout(3, false));
+		try {
+			propertiesSelector.setProperties(index.getCorpus().getOrderedProperties());
+		}
+		catch (CqiClientException e) {
+			Log.printStackTrace(e);
+		}
+		// Listener
+		propertiesSelector.addSelectionListener(computeSelectionListener);
+		
+		//Search button
+		searchButton = new Button(queryArea, SWT.BOLD);
+		searchButton.setText(TXMUIMessages.SEARCH);
 
-		// select focus properties
-		propsArea = new PropertiesSelector<Property>(queryArea, SWT.NONE);
-		propsArea.setLayoutData(new GridData(GridData.FILL, GridData.FILL, false, false));
-		propsArea.setLayout(new GridLayout(3, false));
-		propsArea.addValueChangeListener(new Listener() {
-			@Override
-			public void handleEvent(Event event) {
-				if (!initializing && TXMPreferences.getBoolean(RCPPreferences.AUTO_UPDATE_EDITOR, RCPPreferences.PREFERENCES_NODE)) {
-					updateResultFromEditor();
-					compute(false);
-				}
-			}
-		});
-
-		//propsArea
-		go = new Button(queryArea, SWT.BOLD);
-		go.setText(TXMUIMessages.SEARCH);
-
-		Font f = go.getFont();
+		Font f = searchButton.getFont();
 		FontData defaultFont = f.getFontData()[0];
 		defaultFont.setStyle(SWT.BOLD);
-		Font newf = new Font(go.getDisplay(), defaultFont);
-		go.setFont(newf);
+		Font newf = new Font(searchButton.getDisplay(), defaultFont);
+		searchButton.setFont(newf);
 
 		layoutData = new GridData(GridData.VERTICAL_ALIGN_CENTER);
 		layoutData.horizontalAlignment = GridData.FILL;
 		layoutData.grabExcessHorizontalSpace = false;
-		go.setLayoutData(layoutData);
+		searchButton.setLayoutData(layoutData);
+		searchButton.addSelectionListener(computeSelectionListener);
 
-		SelectionListener listener2 = new SelectionListener() {
-			@Override
-			public void widgetSelected(SelectionEvent e) {
-				updateResultFromEditor();
-				compute(true);
-			}
-			@Override
-			public void widgetDefaultSelected(SelectionEvent e) { }
-		};
-		go.addSelectionListener(listener2);
-
 		// Filters
 		Composite filtercontrols = new Composite(paramArea, SWT.NONE);
 		FormData filtersLayoutData = new FormData();
@@ -384,7 +255,7 @@
 		tmp.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false));
 
 		Label lFmin = new Label(filtercontrols, SWT.NONE);
-		lFmin.setText(TXMCoreMessages.FMIN_1);
+		lFmin.setText(TXMCoreMessages.common_fMin);
 		lFmin.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false));
 
 		GridData fieldsGridData = new GridData(GridData.VERTICAL_ALIGN_END);
@@ -396,7 +267,7 @@
 		fMinSpinner.setIncrement(1);
 		fMinSpinner.setPageIncrement(100);
 		fMinSpinner.setLayoutData(fieldsGridData);
-		fMinSpinner.addKeyListener(listener);
+		fMinSpinner.addKeyListener(computeKeyListener);
 
 		Label lFmax = new Label(filtercontrols, SWT.NONE);
 		lFmax.setText(TXMCoreMessages.FMAX_1);
@@ -408,7 +279,7 @@
 		fMaxSpinner.setIncrement(1);
 		fMaxSpinner.setPageIncrement(100);
 		fMaxSpinner.setLayoutData(fieldsGridData);
-		fMaxSpinner.addKeyListener(listener);
+		fMaxSpinner.addKeyListener(computeKeyListener);
 
 		Label lVmax = new Label(filtercontrols, SWT.NONE);
 		lVmax.setText(TXMCoreMessages.VMAX_1);
@@ -420,7 +291,7 @@
 		vMaxSpinner.setIncrement(1);
 		vMaxSpinner.setPageIncrement(100);
 		vMaxSpinner.setLayoutData(fieldsGridData);
-		vMaxSpinner.addKeyListener(listener);
+		vMaxSpinner.addKeyListener(computeKeyListener);
 
 		Label lNLigneppage = new Label(filtercontrols, SWT.NONE);
 		lNLigneppage.setText(IndexUIMessages.IndexEditor_8);
@@ -440,7 +311,7 @@
 			public void widgetDefaultSelected(SelectionEvent e) {
 				index.setTopLine(0);
 				index.setNLinesPerPage(nLinesPerPageSpinner.getSelection());
-				fillDisplayArea();
+				fillResultArea();
 				viewer.getTable().select(0);
 				viewer.getTable().showSelection();
 			}
@@ -461,7 +332,7 @@
 			public void widgetSelected(SelectionEvent e) {
 				index.setTopLine(0);
 				index.setNLinesPerPage(nLinesPerPageSpinner.getSelection());
-				fillDisplayArea();
+				fillResultArea();
 				viewer.getTable().select(0);
 				viewer.getTable().showSelection();
 			}
@@ -477,7 +348,7 @@
 				int top = i*nLinesPerPageSpinner.getSelection();
 				
 				index.setTopLine(top);
-				fillDisplayArea();
+				fillResultArea();
 				
 				viewer.getTable().select(0);
 				viewer.getTable().showSelection();
@@ -491,7 +362,7 @@
 			@Override
 			public void widgetSelected(SelectionEvent e) {
 				index.setTopLine(index.getTopIndex() + index.getNLinesPerPage());
-				fillDisplayArea();
+				fillResultArea();
 				viewer.getTable().select(0);
 				viewer.getTable().showSelection();
 			}
@@ -506,7 +377,7 @@
 				int top = index.getTopIndex() - index.getNLinesPerPage();
 				if (top < 0) { top = 0; }
 				index.setTopLine(top);
-				fillDisplayArea();
+				fillResultArea();
 				viewer.getTable().select(0);
 				viewer.getTable().showSelection();
 			}
@@ -533,8 +404,7 @@
 		FormLayout resultLayout = new FormLayout();
 		resultArea.setLayout(resultLayout);
 
-		viewer = new TableViewer(resultArea, SWT.MULTI
-				| SWT.FULL_SELECTION | SWT.BORDER);
+		viewer = new TableViewer(resultArea, SWT.MULTI | SWT.FULL_SELECTION | SWT.BORDER);
 		viewer.getTable().setLinesVisible(true);
 		viewer.getTable().setHeaderVisible(true);
 		viewer.getTable().addKeyListener(new TableKeyListener(viewer));
@@ -606,7 +476,7 @@
 				}
 
 				StatusLine.setMessage(TXMUIMessages.SORT_DONE);
-				fillDisplayArea();
+				fillResultArea();
 			}
 
 			@Override
@@ -643,7 +513,7 @@
 					}
 				}
 				StatusLine.setMessage(TXMUIMessages.SORT_DONE);
-				fillDisplayArea();
+				fillResultArea();
 			}
 
 			@Override
@@ -673,112 +543,51 @@
 		separatorColumn.setText(""); //$NON-NLS-1$
 		separatorColumn.pack();
 		paramArea.pack();
-		initializeFields();
 
 		// Register the context menu
-		TXMEditor.initContextMenu(this.viewer.getTable(), "IndexEditorContextMenu", this.getSite(), this.viewer); // $NON-NLS-1$
+		TXMEditor.initContextMenu(this.viewer.getTable(), this.getSite(), this.viewer);
 		
-		viewer.getTable().pack();
-		parent.layout(true);
+		
+		if (queryWidget != null && !queryWidget.isDisposed()) {
+			queryWidget.setFocus();
+		}
+
 	}
 
-	/**
-	 * Gets the pointed column.
-	 *
-	 * @param mouseposition the mouseposition
-	 * @return the pointed column
-	 */
-	public int getPointedColumn(Point mouseposition) {
-		int x = mouseposition.x; // + lineTableViewer.getTable().get;
-		int sumWidthColumn = this.nColumn.getWidth();
-		if (x < sumWidthColumn)
-			return 0;
+	
+	
 
-		sumWidthColumn += this.unitColumn.getWidth();
-		if (x < sumWidthColumn)
-			return 1;
-
-		sumWidthColumn += this.freqColumn.getWidth();
-		if (x < sumWidthColumn)
-			return 2;
-
-		return 2;
+	@Override
+	public void updateResultFromEditor() {
+		// nothing to do
 	}
 
-
-
-	boolean initializing = false; // prevent properties widget listener to activate when adding new properties (and refresh the result)
+	
 	/**
-	 * Initialize fields.
+	 * Computes index.
 	 */
-	public void initializeFields() {
-		initializing = true;
+	@Override
+	public void updateEditorFromResult(final boolean update) {
 
-		// query
-		Query q = index.getQuery();
-		if (q != null) {
-			this.queryWidget.memorize(index.getQuery().getQueryString());
-		} else { // no query
-			queryWidget.setText(""); //$NON-NLS-1$
-		}
+		QueriesView.refresh();
+		RVariablesView.refresh();
 
-		// props
-		if (index.getProperties() != null && index.getProperties().size() > 0) {
-			ArrayList<Property> availables = new ArrayList<Property>();
-			try {
-				for (Property p : index.getCorpus().getOrderedProperties())
-					if (!index.getProperties().contains(p))
-						availables.add(p);
-			} catch (CqiClientException e) {
-				org.txm.rcp.utils.Logger.printStackTrace(e);
-				initializing = false;
-			}
-			ArrayList<Property> props = new ArrayList<Property>();
-			props.addAll(index.getProperties());
-			this.propsArea.setProperties(availables, props);
-		} else {
-			this.propsArea.setCorpus(index.getCorpus());
+		if (!queryWidget.isDisposed()) {
+			queryWidget.memorize();
 		}
 
-		// min, max
-		if (index.getFilterFmin() != null) {
-			this.fMinSpinner.setSelection(index.getFilterFmin());
-		} else {
-			this.fMinSpinner.setSelection(this.getIntParameterValue(IndexPreferences.F_MIN));
-		}
+		fillResultArea();
 
-		if (index.getFilterFmax() != null) {
-			this.fMaxSpinner.setSelection(index.getFilterFmax());
-		} else {
-			this.fMaxSpinner.setSelection(this.getIntParameterValue(IndexPreferences.F_MAX));
-		}
+		viewer.getTable().setFocus();
+	}
 
-		if (index.getFilterVmax() != null) {
-			this.vMaxSpinner.setSelection(index.getFilterVmax());
-		} else {
-			this.vMaxSpinner.setSelection(this.getIntParameterValue(IndexPreferences.V_MAX));
-		}
 
-		if (index.getNLinesPerPage() != null) {
-			this.nLinesPerPageSpinner.setSelection(index.getNLinesPerPage());
-		} else {
-			this.nLinesPerPageSpinner.setSelection(this.getIntParameterValue(IndexPreferences.N_LINES_PER_PAGE));
-		}
 
-		queryWidget.setFocus();
-
-		if (queryWidget != null && !queryWidget.isDisposed()) {
-			queryWidget.setFocus();
-		}
-
-		initializing = false;
-	}
-
 	/**
-	 * Fill display area using the index top index and index number of result per page parameters.
+	 * Fill result area using the index top and index number of results per page parameters.
 	 *
 	 */
-	public void fillDisplayArea() {
+	public void fillResultArea() {
 		// System.out.println("call fill from "+from+" to "+to);
 		int from = index.getTopIndex();
 		
@@ -788,8 +597,10 @@
 		List<Line> lines = null;
 		if (index.getV() > 0) {
 			lines = index.getLines(from, to);
-		} else
+		}
+		else {
 			lines = new ArrayList<Line>();
+		}
 
 		navigationArea.setInfoLineText(""+(from + 1), //$NON-NLS-1$
 				"-" + (to) + " / " + index.getV()); //$NON-NLS-1$ //$NON-NLS-2$
@@ -806,23 +617,18 @@
 		lVInfo.getParent().layout();
 
 		String unitColumnHeader = ""; //$NON-NLS-1$
-		for (Property p : index.getProperties())
+		for (Property p : index.getProperties()) {
 			unitColumnHeader += p.getName() + index.getPropertySeparator();
-		if (unitColumnHeader.length() > 0)
-			unitColumnHeader = unitColumnHeader.substring(0, unitColumnHeader
-					.length() - 1);
+		}
+		if (unitColumnHeader.length() > 0) {
+			unitColumnHeader = unitColumnHeader.substring(0, unitColumnHeader.length() - 1);
+		}
 		unitColumn.setText(unitColumnHeader);
 
 		viewer.setInput(lines);
-		viewer.refresh();
 
 		// Refresh and pack the columns
-		viewer.getControl().setRedraw(false);
-		viewer.refresh();
-		for (TableColumn col : viewer.getTable().getColumns()) {
-			col.pack();
-		}
-		viewer.getControl().setRedraw(true);
+		TXMEditor.packColumns(viewer);
 		
 	}
 
Index: tmp/org.txm.index.rcp/src/org/txm/index/rcp/editors/DictionnaryEditor.java
===================================================================
--- tmp/org.txm.index.rcp/src/org/txm/index/rcp/editors/DictionnaryEditor.java	(revision 722)
+++ tmp/org.txm.index.rcp/src/org/txm/index/rcp/editors/DictionnaryEditor.java	(revision 723)
@@ -20,7 +20,7 @@
 	public void _createPartControl(final Composite parent) {
 		super._createPartControl(parent);
 		
-		this.propsArea.setMaxPropertyNumber(1);
+		this.propertiesSelector.setMaxPropertyNumber(1);
 		this.queryWidget.setText("[]"); //$NON-NLS-1$
 		this.queryWidget.setEnabled(false);
 		this.queryWidget.setVisible(false);
Index: tmp/org.txm.cooccurrence.rcp/src/org/txm/cooccurrence/rcp/editors/CooccurrencesEditor.java
===================================================================
--- tmp/org.txm.cooccurrence.rcp/src/org/txm/cooccurrence/rcp/editors/CooccurrencesEditor.java	(revision 722)
+++ tmp/org.txm.cooccurrence.rcp/src/org/txm/cooccurrence/rcp/editors/CooccurrencesEditor.java	(revision 723)
@@ -64,6 +64,7 @@
 import org.eclipse.ui.IEditorSite;
 import org.eclipse.ui.PartInitException;
 import org.eclipse.ui.PlatformUI;
+import org.txm.concordance.core.preferences.ConcordancePreferences;
 import org.txm.cooccurrence.core.functions.Cooccurrence;
 import org.txm.cooccurrence.core.functions.comparators.CLineComparator;
 import org.txm.cooccurrence.core.functions.comparators.DistComparator;
@@ -76,10 +77,14 @@
 import org.txm.cooccurrence.rcp.messages.CooccurrenceUIMessages;
 import org.txm.core.messages.TXMCoreMessages;
 import org.txm.core.preferences.TXMPreferences;
+import org.txm.core.results.Parameter;
 import org.txm.core.results.TXMParameters;
 import org.txm.rcp.editors.TXMEditor;
 import org.txm.rcp.editors.TXMResultEditorInput;
 import org.txm.rcp.editors.TableKeyListener;
+import org.txm.rcp.editors.listeners.ComputeKeyListener;
+import org.txm.rcp.editors.listeners.ComputeListener;
+import org.txm.rcp.editors.listeners.ComputeSelectionListener;
 import org.txm.rcp.messages.TXMUIMessages;
 import org.txm.rcp.preferences.RCPPreferences;
 import org.txm.rcp.swt.widget.AssistedQueryWidget;
@@ -107,6 +112,7 @@
 
 	// params
 	/** The query widget. */
+	@Parameter(key=CooccurrencePreferences.QUERY)
 	AssistedQueryWidget queryWidget;
 
 	/** The props area. */
@@ -174,7 +180,7 @@
 	public void init(IEditorSite site, IEditorInput input) throws PartInitException {
 		super.init(site, input);
 
-		this.cooc = (Cooccurrence) ((TXMResultEditorInput<Cooccurrence>) input).getResult();
+		this.cooc = (Cooccurrence) ((TXMResultEditorInput<?>) input).getResult();
 	}
 
 	/**
@@ -232,7 +238,7 @@
 		queryArea.setLayout(new GridLayout(3, false));
 
 		Label queryLabel = new Label(queryArea, SWT.NONE);
-		queryLabel.setText(TXMCoreMessages.QUERY_1);
+		queryLabel.setText(TXMCoreMessages.common_query);
 		queryLabel.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, true));
 
 		// [ (v)]
@@ -241,20 +247,8 @@
 		layoutData.horizontalAlignment = GridData.FILL;
 		layoutData.grabExcessHorizontalSpace = true;
 		queryWidget.setLayoutData(layoutData);
-		queryWidget.addKeyListener(new KeyListener() {
-			@Override
-			public void keyPressed(KeyEvent e) {
-				// System.out.println("key pressed : "+e.keyCode);
-				if (e.keyCode == SWT.CR || e.keyCode == SWT.KEYPAD_CR) {
-					cooc.setQuery(queryWidget.getQuery());
-					compute(true);
-				}
-			}
-
-			@Override
-			public void keyReleased(KeyEvent e) { }
-		});
-
+		queryWidget.addKeyListener(new ComputeKeyListener(this));
+		
 //		final Button go = new Button(queryArea, SWT.BOLD);
 //		go.setText(CooccurrenceUIMessages.CooccurrencesEditor_2);
 //
@@ -301,14 +295,7 @@
 		propsArea.setLayout(new GridLayout(4, false));
 		propsArea.setCorpus(this.getCorpus());
 		propsArea.setText(CooccurrenceUIMessages.CooccurrencesEditor_3);
-		propsArea.addValueChangeListener(new Listener() {
-			@Override
-			public void handleEvent(Event event) {
-				if (TXMPreferences.getBoolean(RCPPreferences.AUTO_UPDATE_EDITOR, RCPPreferences.PREFERENCES_NODE)) {
-					compute(true);
-				}
-			}
-		});
+		propsArea.addValueChangeListener(new ComputeListener(this));
 		/*
 		 * FormData propsLayoutData = new FormData(); propsLayoutData.top = new
 		 * FormAttachment (queryArea, 0); propsLayoutData.left = new
@@ -325,24 +312,13 @@
 		Label seuilLabel = new Label(filtercontrols, SWT.NONE);
 		seuilLabel.setText(CooccurrenceUIMessages.CooccurrencesEditor_4);
 
-		SelectionListener thListener = new SelectionListener() {
-			
-			@Override
-			public void widgetSelected(SelectionEvent e) {
-				cooc.setThresfold(TFreq.getSelection(), TCount.getSelection(), TScore.getSelectionCount());
-				compute(true);
-			}
-			
-			@Override
-			public void widgetDefaultSelected(SelectionEvent e) { }
-		};
 		
 		TFreq = new Spinner(filtercontrols, SWT.BORDER);
 		TFreq.setMinimum(1);
 		TFreq.setMaximum(99999);
 		TFreq.setIncrement(1);
 		TFreq.setPageIncrement(100);
-		TFreq.addSelectionListener(thListener);
+		TFreq.addSelectionListener(new ComputeSelectionListener(this));
 
 		seuilLabel = new Label(filtercontrols, SWT.NONE);
 		seuilLabel.setText(CooccurrenceUIMessages.CooccurrencesEditor_5);
@@ -351,26 +327,13 @@
 		TCount.setMaximum(99999);
 		TCount.setIncrement(1);
 		TCount.setPageIncrement(100);
-		TCount.addSelectionListener(thListener);
+		TCount.addSelectionListener(new ComputeSelectionListener(this));
 
 		seuilLabel = new Label(filtercontrols, SWT.NONE);
 		seuilLabel.setText(CooccurrenceUIMessages.CooccurrencesEditor_6);
 		TScore = new Text(filtercontrols, SWT.BORDER);
-		TScore.addSelectionListener(thListener);
-		TScore.addKeyListener(new KeyListener() {
-			@Override
-			public void keyPressed(KeyEvent e) {
-				// System.out.println("key pressed : "+e.keyCode);
-				if (e.keyCode == SWT.CR || e.keyCode == SWT.KEYPAD_CR) {
-					cooc.setThresfold(TFreq.getSelection(), TCount.getSelection(), TScore.getSelectionCount());
-					compute(true);
-				}
-			}
-
-			@Override
-			public void keyReleased(KeyEvent e) {
-			}
-		});
+		TScore.addSelectionListener(new ComputeSelectionListener(this));
+		TScore.addKeyListener(new ComputeKeyListener(this));
 		// empant
 		empantPanel = new EmpantWidget(paramArea, SWT.NONE, this.getCorpus());
 
@@ -380,21 +343,7 @@
 		empantLayoutData.left = new FormAttachment(0);
 		empantLayoutData.right = new FormAttachment(100);
 		empantPanel.setLayoutData(empantLayoutData);
-		empantPanel.addSelectionListener(new SelectionListener() {
-			
-			@Override
-			public void widgetSelected(SelectionEvent e) {
-				cooc.setStructure(empantPanel.getStruct());
-				cooc.setMaxLeft(empantPanel.getMaxLeft() + 1);
-				cooc.setMinLeft(empantPanel.getMinLeft() + 1);
-				cooc.setMinRight(empantPanel.getMinRight() + 1);
-				cooc.setMaxRight(empantPanel.getMaxRight() + 1);
-				cooc.setIncludeXpivot(empantPanel.getXPivot());
-			}
-			
-			@Override
-			public void widgetDefaultSelected(SelectionEvent e) { }
-		});
+		empantPanel.addSelectionListener(new ComputeSelectionListener(this));
 		// result
 		Composite resultArea = this.getResultArea();
 		// FormData resultLayoutData = new FormData();
@@ -738,9 +687,9 @@
 	public void updateEditorFromResult(boolean update) {
 
 		// FIXME: new method
-		Display.getDefault().syncExec(new Runnable() {
-			@Override
-			public void run() {
+//		Display.getDefault().syncExec(new Runnable() {
+//			@Override
+//			public void run() {
 
 				
 				String txt = "tp " + cooc.getNumberOfKeyword() + ", vc " + cooc.getNumberOfDifferentCooccurrents() + ", tc " + cooc.getNumberOfCooccurrents(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
@@ -764,8 +713,8 @@
 				RVariablesView.refresh();
 
 				viewer.getTable().setFocus();
-			}
-		});
+//			}
+//		});
 		
 		// FIXME: old method
 //		JobHandler jobhandler = new JobHandler(NLS.bind(CooccurrenceUIMessages.CooccurrencesEditor_12, cooc.getCorpus())) {
